searchData={"items":[{"type":"module","title":"LazyDoc","doc":"","ref":"LazyDoc.html"},{"type":"module","title":"Main functionality - LazyDoc","doc":"The module LazyDoc provides a way to extract and organize documentation from Elixir source files by reading them, parsing their abstract syntax tree (AST), and collecting relevant information about modules, functions, and comments.","ref":"LazyDoc.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc","doc":"It implements functions to read files matching a given path pattern, extract their AST and comments, group function definitions by names and arities, filter out undocumented functions and modules, and retrieve associated documentation for the extracted modules. The module serves as a utility for generating or managing documentation for Elixir projects.","ref":"LazyDoc.html#module-description"},{"type":"function","title":"LazyDoc.docs_per_module/1","doc":"Parameters\n\nmodules - a list of modules to fetch documentation for.\nDescription\n Retrieves documentation for the given modules, filtering out functions with no documentation.\n\nReturns\n a list of tuples containing the documentation for each module including functions.","ref":"LazyDoc.html#docs_per_module/1"},{"type":"function","title":"LazyDoc.extract_data_from_files/0","doc":"Parameters\n\npath_wildcard - a string pattern used to match file paths for reading.\nDescription\n Reads files that match the given wildcard pattern, extracts their abstract syntax tree (AST), comments, and function definitions.\n\nReturns\n a list of maps containing details about each file, including the content, AST, modules, functions, and comments extracted.","ref":"LazyDoc.html#extract_data_from_files/0"},{"type":"function","title":"LazyDoc.extract_names/1","doc":"Parameters\n\nast - an abstract syntax tree (AST) structure representing the source code.\nDescription\n Initiates the extraction of names from the given AST.\n\nReturns\n a list of names extracted from the AST.","ref":"LazyDoc.html#extract_names/1"},{"type":"function","title":"LazyDoc.filter_undocumented_functions/2","doc":"Parameters\n\nlist_nodes - a list containing nodes which include functions\nlist_undocumented_functions - a list of functions identified as undocumented.\n\nDescription\n Filters a list of nodes to find those that correspond to undocumented functions.\n\nReturns\n a list of nodes that are undocumented functions present in list_nodes.","ref":"LazyDoc.html#filter_undocumented_functions/2"},{"type":"function","title":"LazyDoc.filter_undocumented_modules/1","doc":"","ref":"LazyDoc.html#filter_undocumented_modules/1"},{"type":"function","title":"Parameters - LazyDoc.filter_undocumented_modules/1","doc":"- zip_to_process - a list of tuples containing module information and their documentation.","ref":"LazyDoc.html#filter_undocumented_modules/1-parameters"},{"type":"function","title":"Description - LazyDoc.filter_undocumented_modules/1","doc":"Filters the given list of modules and returns those that do not have associated documentation.","ref":"LazyDoc.html#filter_undocumented_modules/1-description"},{"type":"function","title":"Returns - LazyDoc.filter_undocumented_modules/1","doc":"A list of tuples containing modules and their respective AST and code without documentation.","ref":"LazyDoc.html#filter_undocumented_modules/1-returns"},{"type":"function","title":"LazyDoc.group_docs_different_arities/1","doc":"Parameters\n\nfunc_docs - a list of function documentation tuples, where each tuple contains the function name, line number, signature, and documentation string.\nDescription\n Groups function documentation by their names in order to organize and access documentation for functions with different arities.\n\nReturns\n a map where the keys are function names and the values are lists of their corresponding documentation strings.","ref":"LazyDoc.html#group_docs_different_arities/1"},{"type":"function","title":"LazyDoc.join_code_from_clauses/1","doc":"Parameters\n\nnames - a list of tuples where each tuple contains a type and a value. The type indicates the kind of element (e.g., :function) and the value is related to that type.\nDescription\n Joins code from function clauses based on their names, merging the code of functions with the same name.\n\nReturns\n a list of elements where functions with the same name are combined into a single tuple with their code concatenated.","ref":"LazyDoc.html#join_code_from_clauses/1"},{"type":"module","title":"LazyDoc.Application","doc":"","ref":"LazyDoc.Application.html"},{"type":"module","title":"Main functionality - LazyDoc.Application","doc":"The module LazyDoc.Application is responsible for initiating the application process in the LazyDoc system.","ref":"LazyDoc.Application.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc.Application","doc":"It provides a start function that allows for the initiation of application processes with specified start parameters. The function returns the process identifier of the newly started process, which can be utilized for further interactions within the application.","ref":"LazyDoc.Application.html#module-description"},{"type":"function","title":"LazyDoc.Application.start/2","doc":"Parameters\n\n_start_type - Specifies the type of start operation being initiated.\n_start_args - Contains additional arguments needed for starting the operation.\n\nReturns\n {:ok, pid} where pid is the process identifier of the newly started process.","ref":"LazyDoc.Application.html#start/2"},{"type":"module","title":"LazyDoc.Example","doc":"Documentation for `LazyDoc`.\n\nThis module is an example of autogenerated docs by\nthe task provided.","ref":"LazyDoc.Example.html"},{"type":"function","title":"LazyDoc.Example.func_without_doc/0","doc":"Parameters\n\nNone\nDescription\n Outputs \"Hello world\" to the console.\n\nReturns\n None","ref":"LazyDoc.Example.html#func_without_doc/0"},{"type":"function","title":"LazyDoc.Example.hello/0","doc":"Hello world.","ref":"LazyDoc.Example.html#hello/0"},{"type":"function","title":"Examples - LazyDoc.Example.hello/0","doc":"iex> LazyDoc.hello()\n    :world","ref":"LazyDoc.Example.html#hello/0-examples"},{"type":"function","title":"LazyDoc.Example.my_func/1","doc":"Parameters\n\nn - an integer that can take different values.\nDescription\n Returns a string representing the number.\n\nReturns\n a string indicating the value of n, with specific responses for 1 and 2.","ref":"LazyDoc.Example.html#my_func/1"},{"type":"function","title":"LazyDoc.Example.my_func_2/1","doc":"Parameters\n\nn - an integer input to the function.\nDescription\n Returns a string representation of the input number.\n\nReturns\n a string that indicates the value of n","ref":"LazyDoc.Example.html#my_func_2/1"},{"type":"behaviour","title":"LazyDoc.Provider","doc":"","ref":"LazyDoc.Provider.html"},{"type":"behaviour","title":"Main functionality - LazyDoc.Provider","doc":"The module LazyDoc.Provider provides a standard interface for making requests to an external service and processing the responses.","ref":"LazyDoc.Provider.html#module-main-functionality"},{"type":"behaviour","title":"Description - LazyDoc.Provider","doc":"It defines a set of callbacks and functions that allow a user to request a prompt, retrieve documents from a response, and interact with models, enabling flexible integration with various providers that conform to this interface.","ref":"LazyDoc.Provider.html#module-description"},{"type":"callback","title":"LazyDoc.Provider.check_parameters?/1","doc":"","ref":"LazyDoc.Provider.html#c:check_parameters?/1"},{"type":"function","title":"LazyDoc.Provider.check_parameters?/2","doc":"","ref":"LazyDoc.Provider.html#check_parameters?/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.check_parameters?/2","doc":"- callback_module - the module that contains the check_parameters? function to be called.\n- params - the parameters that need to be validated.","ref":"LazyDoc.Provider.html#check_parameters?/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.check_parameters?/2","doc":"Validates the parameters by delegating the check to a specified callback module.","ref":"LazyDoc.Provider.html#check_parameters?/2-description"},{"type":"function","title":"Returns - LazyDoc.Provider.check_parameters?/2","doc":"the result of the parameter validation from the callback module.","ref":"LazyDoc.Provider.html#check_parameters?/2-returns"},{"type":"callback","title":"LazyDoc.Provider.get_docs_from_response/1","doc":"","ref":"LazyDoc.Provider.html#c:get_docs_from_response/1"},{"type":"function","title":"LazyDoc.Provider.get_docs_from_response/2","doc":"Parameters\n\ncallback_module - a module that implements the method to retrieve documents.\nresponse - data received from an external source that needs to be processed.\n\nDescription\n Calls the method get_docs_from_response on the provided callback_module with the given response to retrieve documents.\n\nReturns\n the documents extracted from the response.","ref":"LazyDoc.Provider.html#get_docs_from_response/2"},{"type":"callback","title":"LazyDoc.Provider.model/1","doc":"","ref":"LazyDoc.Provider.html#c:model/1"},{"type":"function","title":"LazyDoc.Provider.model/2","doc":"Parameters\n\ncallback_module - a module that contains the model function to be invoked.\nmodel - the model that needs to be passed to the callback module's model function.\nDescription\n Invokes the model function of the provided callback module with the specified model.\n\nReturns\n the result from the callback module's model function.","ref":"LazyDoc.Provider.html#model/2"},{"type":"callback","title":"LazyDoc.Provider.request_prompt/4","doc":"","ref":"LazyDoc.Provider.html#c:request_prompt/4"},{"type":"function","title":"LazyDoc.Provider.request_prompt/5","doc":"Parameters\n\ncallback_module - a module that handles the request for the prompt.\nprompt - the text prompt to be processed.\nmodel - the model to be used for generating the response to the prompt.\ntoken - authorization token to access the service.\n\nDescription\n Initiates a request to generate a response based on the provided prompt using the specified model and token.\n\nReturns\n the response generated by the callback_module for the given prompt.","ref":"LazyDoc.Provider.html#request_prompt/5"},{"type":"module","title":"LazyDoc.Providers.GithubAi","doc":"","ref":"LazyDoc.Providers.GithubAi.html"},{"type":"module","title":"Main functionality - LazyDoc.Providers.GithubAi","doc":"The module LazyDoc.Providers.GithubAi provides a way of interacting with the Github AI API for prompt-based communication and response generation.","ref":"LazyDoc.Providers.GithubAi.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc.Providers.GithubAi","doc":"It implements the behavior Provider, offering a standardized method to request and retrieve responses from AI models hosted on the Github AI platform. Key operations include sending prompts, constructing API requests, and processing responses.","ref":"LazyDoc.Providers.GithubAi.html#module-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"- params - a list of parameters to check, where each parameter is a tuple containing a key and a value.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"Validates if all keys in the params list match the accepted parameters.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-description"},{"type":"function","title":"Returns - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"true if all parameters are valid; false otherwise.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-returns"},{"type":"function","title":"LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"Parameters\n\nresponse - a %Req.Response struct containing the response from an HTTP request.\nDescription\n Parses the body of the HTTP response and extracts the message content from it.\n\nReturns\n the content of the message extracted from the response body.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1"},{"type":"function","title":"LazyDoc.Providers.GithubAi.model/1","doc":"Parameters\n\nmodel - a symbol representing the model type.\nDescription\n Maps the provided model symbol to its corresponding string representation.\n\nReturns\n the string representation of the specified model.","ref":"LazyDoc.Providers.GithubAi.html#model/1"},{"type":"function","title":"LazyDoc.Providers.GithubAi.req_query/4","doc":"Parameters\n\nprompt - the input text or question to be sent to the model.\nmodel - the identifier for the specific model to use for generating a response.\ntoken - the authorization token required for accessing the API.\n\nDescription\n Constructs a request to query an AI model with a given prompt and specified parameters.\n\nReturns\n a structured request object ready to interact with the API at the configured endpoint.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4"},{"type":"function","title":"LazyDoc.Providers.GithubAi.request_prompt/4","doc":"Parameters\n\nprompt - the input message to be processed by the model.\nmodel - the identifier for the specific AI model to be used.\ntoken - the authorization token for accessing the AI service.\n\nDescription\n Sends a prompt to an AI model and returns the generated response.\n\nReturns\n the response generated by the AI model based on the provided prompt.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4"},{"type":"task","title":"mix lazy_doc","doc":"","ref":"Mix.Tasks.LazyDoc.html"},{"type":"task","title":"Main functionality - mix lazy_doc","doc":"The module Mix.Tasks.LazyDoc provides a Mix task for processing source files to extract and format documentation for Elixir modules and functions.","ref":"Mix.Tasks.LazyDoc.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc","doc":"It enables the extraction of documentation using AI to enhance the documentation generation process, verifying and formatting documentation as per specified requirements. It handles reading the source code, interacting with a provider for documentation prompts, and writing the results back in a structured format.","ref":"Mix.Tasks.LazyDoc.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"Parameters\n\ndocs - a string representing the documentation to be validated.\nDescription\n Checks if the provided documentation format is correct.\n\nReturns\n true if the documentation is formatted correctly, false otherwise.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1"},{"type":"function","title":"Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"- docs - the documentation string to be converted to an abstract syntax tree (AST).\n- acc_ast - the accumulator AST to which the new documentation will be added.\n- module_ast - the AST of the module where the documentation will be inserted.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"Converts a documentation string into an Elixir AST and inserts it into the specified module's AST.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"the updated accumulator AST after inserting the new documentation.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"This should work for most of the modules, it will not work if the module contains only one function because Elixir does not create a `__block__` node in this case.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"- ast - the Abstract Syntax Tree (AST) representing the module structure.\n- module_ast - the AST representation of the specific module to be modified.\n- ast_doc - a documentation string or AST node to be inserted into the module.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"Inserts documentation into a specified module in the AST by traversing and modifying the module's structure.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"The modified AST with the new documentation inserted.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"Parameters\n\n_module - the module to which the nodes will be inserted.\nmodule_ast - the abstract syntax tree of the module.\nfunctions - a list of functions to be processed.\nfinal_prompt - a string prompt to be appended to each function's prompt.\nprovider_mod - the module responsible for making requests to the provider.\nmodel_text - the text representation of the model used in the request.\ntoken - the authentication token for the provider.\nacc - the accumulator for building the updated abstract syntax tree.\n\nDescription\n Inserts nodes into a module based on provided functions and prompts.\n\nReturns\n the updated abstract syntax tree after processing the functions.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7"},{"type":"function","title":"Mix.Tasks.LazyDoc.proccess_files/1","doc":"Parameters\n\nentries - a list of entry structures containing functions and associated ASTs.\nDescription\n A list of entries to process, transforming functions based on model responses.\n\nReturns\n None","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1"},{"type":"function","title":"Mix.Tasks.LazyDoc.run/1","doc":"Parameters\n\n_command_line_args - command line arguments provided to the function.\nDescription\n Runs the main application logic for the LazyDoc utility, processing source files to extract documentation.\n\nReturns\n None","ref":"Mix.Tasks.LazyDoc.html#run/1"},{"type":"function","title":"Mix.Tasks.LazyDoc.write_to_file/2","doc":"write to given file the given Elixir AST\nThis function does not write it in the proper format and it will remove comments as well","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2"},{"type":"function","title":"Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"- file - the name of the file where the formatted content will be written.\n- ast - the abstract syntax tree representation of the code to be written.\n- comments - optional comments to include with the formatted output.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"Formats the given abstract syntax tree (AST) and writes it to the specified file, including any provided comments.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":":ok if the write operation is successful, or {:error, reason} if it fails.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-returns"},{"type":"task","title":"mix lazy_doc.check","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html"},{"type":"task","title":"Main functionality - mix lazy_doc.check","doc":"The module Mix.Tasks.LazyDoc.Check is designed to facilitate the checking of documentation for functions and modules within a codebase using the LazyDoc application.","ref":"Mix.Tasks.LazyDoc.Check.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc.check","doc":"It initializes the LazyDoc application, identifies undocumented functions and modules across specified files, and exits with an appropriate status code based on the presence of undocumented elements. Warnings are logged for any undocumented functions and modules encountered during the check.","ref":"Mix.Tasks.LazyDoc.Check.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"- entry_functions - a list of tuples representing modules and their functions.\n- file - the file where the undocumented functions are being printed.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"Iterates through a list of entry functions and prints warnings for modules that contain undocumented functions.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"a list of modules that have undocumented functions.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"- modules - a list of modules to check for documentation.\n- file - the name of the file where the modules are located.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"Checks if the provided modules are documented and logs warnings for any undocumented modules.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"true if there are undocumented modules, false otherwise.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"- functions - a list of functions to check for documentation.\n- mod - the module name where the functions are defined.\n- file - the filename where the module is located.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"Logs warnings for each function in the list that lacks documentation and provides information about the module and file.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"nil","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.run/1","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.run/1","doc":"- _command_line_args - arguments passed via the command line interface.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.run/1","doc":"Initializes the LazyDoc application, checks for undocumented functions in the specified files, and gracefully exits based on the findings.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.run/1","doc":"Exits the application with a status code indicating the presence of undocumented functions (1 if found, 0 if none).","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-returns"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}